---
title: "Step 1: Send an authorization request"
component: pingone-api
page_id: pingone-api:workflow-library:pingone-mfa/login-with-multifactor-authentication/test-the-workflow/step-14-send-an-authorization-request
canonical_url: https://developer.pingidentity.com/pingone-api/workflow-library/pingone-mfa/login-with-multifactor-authentication/test-the-workflow/step-14-send-an-authorization-request.html
section_ids:
  example-request: Example Request
  example-response: Example Response
---

# Step 1: Send an authorization request

##

   

```none
GET {{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid
```

The PingOne authorization endpoint `/{{envID}}/as/authorize` is used to interact with the resource owner and obtain an authorization grant. The authorization request must include values for the following properties:

* `client_id`

  A string that specifies the application's ID.

* `response_type`

  A string that specifies the code or token type returned by an authorization request. For this activity, the value is `code`.

* `redirect_uri`

  A string that specifies the URL that specifies the return entry point of the application. The `redirect_uri` property value defined in the applpication configuration.

* `scope`

  A string that specifies permissions that determine the resources that the application can access.

* `response_mode`

  A Ping Identity custom response mode to specify that the authorization response parameters are encoded as a JSON object wrapped in a flow response and returned directly to the client with a 200 status.

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https%3A%2F%2Fwww.google.com&response_mode=pi.flow&scope=openid'
```

```csharp
var options = new RestClientOptions("{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Get);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https%3A%2F%2Fwww.google.com&response_mode=pi.flow&scope=openid"
  method := "GET"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
GET /{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid HTTP/1.1
Host: {{authPath}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid")
  .method("GET", body)
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid",
  "method": "GET",
  "timeout": 0,
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'GET',
  'url': '{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid',
  'headers': {
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid"

payload = {}
headers = {}

response = requests.request("GET", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid');
$request->setMethod(HTTP_Request2::METHOD_GET);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https://www.google.com&response_mode=pi.flow&scope=openid")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/as/authorize?response_type=code&client_id={{webApp4MfaId}}&redirect_uri=https%3A%2F%2Fwww.google.com&response_mode=pi.flow&scope=openid")!,timeoutInterval: Double.infinity)
request.httpMethod = "GET"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "usernamePassword.check": {
            "href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/0359cd9b-1c98-4cb1-abd4-0fed7cee223b"
        },
        "password.forgot": {
            "href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/0359cd9b-1c98-4cb1-abd4-0fed7cee223b"
        },
        "self": {
            "href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/0359cd9b-1c98-4cb1-abd4-0fed7cee223b"
        },
        "signOnPage": {
            "href": "https://apps.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signon/?flowId=0359cd9b-1c98-4cb1-abd4-0fed7cee223b"
        }
    },
    "_embedded": {
        "application": {
            "name": "WebAppWithMFA_1776884203"
        }
    },
    "id": "0359cd9b-1c98-4cb1-abd4-0fed7cee223b",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "resumeUrl": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/as/resume?flowId=0359cd9b-1c98-4cb1-abd4-0fed7cee223b",
    "status": "USERNAME_PASSWORD_REQUIRED",
    "createdAt": "2026-04-22T18:59:25.639Z",
    "expiresAt": "2026-04-22T19:14:25.639Z"
}
```
